package io.zipcoder;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.*;

public class WC {
    private Iterator<String> si;
    private  Map<String, Integer> countWords;

    public WC(String fileName) {
        try {
            Scanner scanner = new Scanner(new FileReader(fileName));
            scanner.useDelimiter("[\\p{Punct}\\s]");
            si = scanner;

        } catch (FileNotFoundException e) {
            System.out.println(fileName + " Does Not Exist");
            System.exit(-1);
        }
        countWords = new HashMap<String, Integer>();
        while (si.hasNext()){
            String next = si.next().toLowerCase();
            Integer count = countWords.get(next);
            if (count != null) {
                countWords.put(next, count + 1);
            } else {
                countWords.put(next, 1);
            }

//            for (String key : countWords.keySet()){
//                System.out.print(key + ": " + countWords.get(key) + "\n");
//            }
        }
    }

    public void orderList(String fileName){

        countWords.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
        .forEach(System.out::println);
    }

    public WC(Iterator<String> si) {
        this.si = si;
    }

}
