package io.zipcoder;

import org.junit.Assert;
import org.junit.Test;

public class ParenCheckerTest {

    @Test
    public void isMatchingpairTrueTest(){
        char char1 = '(';
        char char2 = ')';
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.isMatchingpair(char1, char2);
        Assert.assertTrue(actual);
    }

    @Test
    public void isMatchingpairFalseTest(){
        char char1 = '(';
        char char2 = '(';
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.isMatchingpair(char1, char2);
        Assert.assertFalse(actual);

    }

    @Test
    public void areParenBalancedTrueTest(){
        String brackets = "(((()()))())";
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.balPare(brackets, '(', ')');
        Assert.assertTrue(actual);
    }

    @Test
    public void areParenBalancedFalseTest(){
        String brackets = "))))))";
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.balPare(brackets, '(', ')');
        Assert.assertFalse(actual);
    }

    @Test
    public void balancedCharacterTestEven(){
        String brackets = "({}[])('')]";
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.balancedCharacters(brackets);
        Assert.assertFalse(actual);
    }

    @Test
    public void balancedCharacterTestOdd(){
        String brackets = "({}[('')";
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.balancedCharacters(brackets);
        Assert.assertFalse(actual);
    }

    @Test
    public void balancedCharacterTestTrueeven(){
        String brackets = "([{''}{\"\"}])";
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.balancedCharacters(brackets);
        Assert.assertTrue(actual);
    }
}